#!/usr/local/bin/perl

sub ShowLine {
	my($line) = @_;

	my($len)	= length($line);
	my($begin)	= 0;
	my($ss)		= '';

	### banner stuff
	my($banner)	= ' ';
	for($i = 1; $i < 8; $i++) {
		$banner	.= ' ' x 9;
		$banner .= $i;
	}
	$banner		.= "\n" . '0123456789' x 8;
	$banner		.= "\n";

	print "$banner$line\n\n";
	#while($begin < $len) {
	#	$end 	= $len < ($begin + 80) ? $len : ($begin + 80);
	#	print "begin = $begin, end = $end\n";
	#	$ss		= substr($line,$begin,$end);
	#	print "\n${banner}$ss\n";
	#	$begin += 80;
	#}
}

sub SplitTCLList {
	my($line)	= @_;
	my(@arr);

	my($debug) 	= 0;
	my($curpos)	= 0;
	my($len)	= length($line);
	my($state)	= 0;
	my($word)	= '';
	my($end);
	my($oq)		= '{';
	my($cq)		= '}';

	if ($debug) {select(STDERR);}	# make sure the dbg crap goes to STDERR

	if ($debug) {
		print "\n-- Entering SplitTCLList --\n";
		print "line: [$line]\n";
	}
	
	while($curpos < $len) {
		$char = substr($line,$curpos,1);
		if ($debug) {print "CHAR: [$char], POS: $curpos\n";}
		if ($char eq $oq) {
			$state++;
			if ($debug) {print "hit $oq, setting state to $state\n";}
			if ($state == 1) {
				if (length($word)) {push(@arr,$word); $word = '';}
				$begin = $curpos + 1;	# skip beginning open-curly
				if ($debug) {print "setting begin=$begin\n";}
			}
		} elsif ($char eq $cq) {
			$state--;
			if ($state < 0) {die "whoops! state went negative.\n";}
			if ($debug) {print "hit $cq, setting state to $state\n";}
			if ($state == 0) {
				$end = $curpos - 1;
				$sub = substr($line,$begin,$end - $begin + 1);
				push(@arr,$sub);
				if ($debug) {print "%% SAVING str ${begin}-${end}\n";}
				if ($debug) {print "%% SAVING %% sub = [$sub]\n";}
			}
		} elsif (!$state) {
			if ($char eq ' ') {
				if (length($word)) {
					push(@arr,$word);
					if ($debug) {print "saving word=[$word]\n";}
					$word = '';
				} elsif ($debug)  {
					print "found separator outside large string\n";
				}
			} else {
				$word .= $char;
				if ($debug) {print "adding [$char] to word [$word]\n";}
			}
		}
		$curpos++;
	}
	if ($state) {
		print "didn't find last closing-quote.\n";
		exit(-1);
	}
	if (length($word)) {
		push(@arr,$word);
	}
	if ($debug) {select(STDOUT);}
	@arr;
}

sub ShowArr {
	my(@arr) = @_;
	my($count,$foo);

	print STDERR "\n------------------ record --------------------\n";
	$count = 0;
	foreach $foo (@arr) {
		print STDERR "[$count] $foo\n";
		$count++;
	}
}

sub DumpRec {
	my($lastname,$firstname,$street,$city,$zip,$country,@tel) = @_;
	my($telnum);

	select(STDERR);
	print "\n-------- New Record ---------\n";
	print sprintf("LAST  : %-20s FIRST: %-20s\n",$lastname,$firstname);
	print sprintf("STREET: %-20s CITY: %-15s ZIP: %-10s CNTRY: %s\n",
		$street,$city,$zip,$country);
	foreach $telnum (@tel) {
		print sprintf("PHONE#: %s\n",$telnum);
	}
	print "FAX   : $fax\n";
	print "EMAIL : $email\n";
	print sprintf("MISC  : %-30.30s\n",$misc);
	select(STDOUT);
}

sub Holes {
	my($count);
	my($x,$y) = ($HoleToSide,0-$HoleToTop);
	my($hole);

	print OUT "\n%%% Holes START %%%\n";
	#for($count = 0; $count < $NumHoles; $count++) {
	#	print OUT "$x cm $y cm $HoleRadius cm DoCircle\n";
	#	$y -= $HoleSeparation;
	#}
	foreach $hole (@HOLES) {
		($x,$y) = split(/,/,$hole);
		print OUT "$x cm -$y cm $HoleRadius cm DoCircle\n";
	}
	print OUT "%%% Holes END   %%%\n\n";
}

sub ClipAddress {
	my($vd)			= -($PAGEHEIGHT - $TOPMARGIN - $BOTMARGIN);

	print OUT "%%% ClipAddress start %%%\n";
	print OUT "initclip newpath\n";
	print OUT "$LEFTMARGIN cm -$TOPMARGIN cm moveto\n";
	print OUT "0 $vd cm rlineto\n";
	print OUT "$ADDRWIDTH cm 0 rlineto\n";
	print OUT "0 ", -$vd, " cm rlineto\n";
	print OUT "closepath clip\n";
	#print OUT "closepath [2 2] 0 setdash stroke\n";
	print OUT "%%% ClipAddress end %%%\n\n";
}

sub ClipTelephone {
	my($vd)			= -($PAGEHEIGHT - $TOPMARGIN - $BOTMARGIN);

	print OUT "%%% ClipTelephone start %%%\n";
	print OUT "initclip newpath\n";
	print OUT "$TELSTART cm -$TOPMARGIN cm moveto\n";
	print OUT "0 $vd cm rlineto\n";
	print OUT "$TELWIDTH cm 0 rlineto\n";
	print OUT "0 ", -$vd, " cm rlineto\n";
	print OUT "closepath clip\n";
	#print OUT "closepath [3 3] 0 setdash stroke\n";
	print OUT "%%% ClipTelephone end   %%%\n\n";
}

sub CrossHairs {
	my($x);
	foreach $x (0, $PAGEWIDTH, 2*$PAGEWIDTH) {
		print OUT "$x cm 0 crosshairs\n";
		print OUT "$x cm -$PAGEHEIGHT cm crosshairs\n";
		print OUT "$x cm ",-2*$PAGEHEIGHT," cm crosshairs\n";
	}
}

sub NewPhysicalPage {
	print OUT "%%% NewPhysicalPage %%%\n";
	if ($PHYSPAGE != 0) {
		print OUT "showpage\n\n";
	}
	if ($ORIENTATION eq '4up') {
		print OUT "0 $PAPERHEIGHT cm translate	% mk origin up-left corner\n";
	} else {
		print OUT "90 rotate	% make origin upper-left corner\n";
	}
	print OUT "1.0 cm -1.0 cm translate	% mv origin into imagable space\n";
	Holes();
	CrossHairs();
	print OUT "%%% END NewPhysicalPage %%%\n\n";
	$PHYSPAGE++;
	InitCurY();
}

sub NewPhysicalPage4up {
	print OUT "%%% NewPhysicalPage %%%\n";
	if ($PHYSPAGE != 0) {
		print OUT "showpage\n\n";
	}
	print OUT "0 $PAPERHEIGHT cm translate	% make origin upper-left corner\n";
	print OUT "1.0 cm -1.0 cm translate	% move origin into imagable space\n";
	Holes();
	CrossHairs();
	print OUT "%%% END NewPhysicalPage %%%\n\n";
	$PHYSPAGE++;		# don't need this (yet)
	InitCurY();
}

sub InitCurY {
	$CUR_Y		= -($TOPMARGIN * $PTSPERCM + $FONTSCALE);	# reset
}

sub NewLogicalPage {
	my($newx,$newy);

	$LOGPAGE++;
	$FIRSTMARK = 1;
	my($lpm) = $LOGPAGE % $PAGESPERSHEET;
	if ($lpm == 0) {
		NewPhysicalPage();
		return;
	}
	if ($lpm == 1) {
		$newx	= $PAGEWIDTH;
		$newy	= 0;
	} elsif ($lpm == 2) {
		$newx	= -$PAGEWIDTH;
		$newy	= -$PAGEHEIGHT;
	} elsif ($lpm == 3) {
		$newx	= $PAGEWIDTH;
		$newy	= 0;
	}
	print OUT "%%% NewLogicalPage (logpage = $LOGPAGE) %%%\n";
	print OUT "$newx cm $newy cm translate\n";
	print OUT "%%% END NewLogicalPage %%%\n\n";
	InitCurY();
}

sub SetupFonts {
	print OUT "%%% SetupFonts START %%%\n";
	print OUT "/$FONTNAME /${FONTNAME}-Enhanced accentvec ReEncodeSmall\n";
	#print OUT "/${FONTNAME}-Enhanced findfont $FONTSCALE scalefont setfont\n";
	print OUT "/NormalFont /${FONTNAME}-Enhanced findfont $FONTSCALE scalefont def\n";
	print OUT "/HeaderFont /${FONTNAME}-Enhanced findfont $HEADERSCALE scalefont def\n";
	print OUT "HeaderFont setfont\n";	# so FindHeight will work currectly
	print OUT "FindHeight\n";
	print OUT "NormalFont setfont\n";
	print OUT "%%% SetupFonts END   %%%\n\n";
}

sub HeaderFont {
	print OUT "HeaderFont setfont\n";
}

sub NormalFont {
	print OUT "NormalFont setfont\n";
}

sub OldDoHeader {
	HeaderFont();
	my($mid) = ($PAGEWIDTH - $LEFTMARGIN)/2 + $LEFTMARGIN - 0.4;
	my($y)	= -$HEADERSCALE;
	print OUT "$mid cm $y moveto\n";
	print OUT "($FIRSTLET - $LASTLET) show\n";
	NormalFont();
	print OUT "0.05 cm setlinewidth newpath\n";
	print OUT "$LEFTMARGIN cm ", -$TOPMARGIN, " cm  moveto\n";
	print OUT "0 $TOPMARGIN cm rlineto\n";
	print OUT $PAGEWIDTH - $LEFTMARGIN, " cm 0 rlineto\n";
	print OUT "0 -$TOPMARGIN cm rlineto closepath stroke\n";
	#print OUT $PAGEWIDTH - $LEFTMARGIN, " cm 0 rlineto stroke\n";
	print OUT "0 setlinewidth\n";
}

sub DoHeader {
	HeaderFont();
	print OUT "$LEFTMARGIN cm 0\n";					# put x1 y1 on stack
	print OUT "$PAGEWIDTH cm -$TOPMARGIN cm \n";	# x2 y2
	print OUT "($FIRSTLET \\320 $LASTLET) DoHeader\n";
	NormalFont();
}

sub FormatPS {
	my($line) = @_;
	my($tmp);

	@arr = SplitTCLList($line);
	#if ($debug) {ShowLine($_);ShowArr(@arr);}
	my($name,$addr,$telephone,$fax,$email,$misc,$lastmod) = @arr;

	my($lastname,$firstname)		= SplitTCLList($name);
	my($street,$city,$zip,$country)	= SplitTCLList($addr);
	my(@T)							= SplitTCLList($telephone);
	#if ($debug) {
	#	DumpRec($lastname,$firstname,$street,$city,$zip,$country,@T);
	#}

	# first address side
	my(@A) = ();
	$tmp = $lastname;
	if ($firstname) {$tmp .= ", $firstname";}
	push(@A,$tmp);
	if ($street) {push(@A,$street);}
	#if ($city) {push(@A,$city);}
	$tmp = $zip;
	if ($country) {
		if ($zip) {$tmp .= ", $country";} else {$tmp = $country;}
	}
	if (length($city) < 20) {
		# pack City, State, Zip, and Country on one line
		if ($city) {
			if ($tmp) {
				$tmp = "$city $tmp";
				push(@A,$tmp);
			}
		} elsif ($tmp) {
			push(@A,$tmp);
		}
	} else {
		if ($city) {push(@A,$city);}
		if ($tmp) {push(@A,$tmp);}
	}
	if ($email) {push(@A,$email);}

	# then telephone side
	if ($fax) {push(@T,"$fax (fax)");}
	my($longer) = scalar(@A) > scalar(@T) ? scalar(@A) : scalar(@T);
	my($stillgot,$need);
	$stillgot	= abs($BOT_Y) - abs($CUR_Y) + $FONTSCALE;
	$need		= $longer * $FONTSCALE;
	#if (($BOT_Y - $CUR_Y + $FONTSCALE) < ($longer * $FONTSCALE)) {
	#Dbg("$lastname: stillgot=$stillgot, need=$need");
	if ($stillgot < $need) {
		DoHeader();
		NewLogicalPage();
	}
	if ($FIRSTMARK) {
		$FIRSTMARK = 0;
		#print "Name=$name, first mark...\n";
		$FIRSTLET = ucfirst(substr($lastname,0,2));
	} else {
		# draw line between entries...
		$tmp = $CUR_Y + ($FONTSCALE * 1.5);
		#print "Name=$name, drawing line at Y=$tmp\n";
		print OUT "0 setlinewidth newpath\n";
		print OUT "$LEFTMARGIN cm $tmp moveto\n";
		print OUT $PAGEWIDTH - $LEFTMARGIN - $RIGHTMARGIN,
			" cm 0 rlineto stroke\n";
	}

	# first do address side
	# save first letter of last name for header
	$LASTLET = ucfirst(substr($lastname,0,2));
	my($cur_y) = $CUR_Y;	# CUR_Y can't change yet
	#ClipAddress();
	foreach $tmp (@A) {
		print OUT "$LEFTMARGIN cm $cur_y moveto\n";
		#print OUT "($tmp) show\n";
		print OUT "($tmp) ShowAddr\n";
		$cur_y -= $FONTSCALE;
	}
	# then do telephone side
	#ClipTelephone();
	$cur_y = $CUR_Y;
	foreach $tmp (@T) {
		print OUT "$TELSTART cm $cur_y moveto\n";
		#print OUT "($tmp) show\n";
		print OUT "($tmp) ShowTel\n";
		$cur_y -= $FONTSCALE;
	}
	$CUR_Y -= (($longer + 1) * $FONTSCALE);
	#print OUT "initclip\n";		# reset clipping to default
}

sub PageSetup {
	if ($PAPERSIZE eq 'A4') {
		$PAPERWIDTH = $A4WIDTH;
		$PAPERHEIGHT = $A4HEIGHT;
	} else {
		$PAPERWIDTH = $USWIDTH;
		$PAPERHEIGHT = $USHEIGHT;
	}
	if (((2 * $PAGEWIDTH) > ($PAPERWIDTH - 2))||
		((2 * $PAGEHEIGHT) > ($PAPERHEIGHT - 2))) {
		$ORIENTATION='2up';
		$PAGESPERSHEET = 2;
		Dbg("too fat or too high");
	} else {
		$ORIENTATION='4up';
		$PAGESPERSHEET = 4;
	}
	Dbg("PAGESPERSHEET=$PAGESPERSHEET");
	Dbg("ORIENTATION=$ORIENTATION\n");
}

sub Dbg {
	my($msg) = @_;
	if ($debug) {print "$msg\n";}
}

sub ParseArgs {
	#### get args
	while($arg = shift(@ARGV)) {
		if ($arg =~ /-ps/) {
			$PAPERSIZE = shift(@ARGV);
		} elsif ($arg =~ /-pw/) {
			$PAGEWIDTH = shift(@ARGV);
		} elsif ($arg =~ /-ph/) {
			$PAGEHEIGHT = shift(@ARGV);
		} elsif ($arg =~ /-tm/) {
			$TOPMARGIN = shift(@ARGV);
		} elsif ($arg =~ /-bm/) {
			$BOTMARGIN = shift(@ARGV);
		} elsif ($arg =~ /-lm/) {
			$LEFTMARGIN = shift(@ARGV);
		} elsif ($arg =~ /-rm/) {
			$RIGHTMARGIN = shift(@ARGV);
		} elsif ($arg =~ /-fn/) {
			$FONTNAME = shift(@ARGV);
		} elsif ($arg =~ /-fs/) {
			$FONTSCALE =  shift(@ARGV);
		} elsif ($arg =~ /-hd/) {
			$HoleRadius = 2 * shift(@ARGV);
		} elsif ($arg =~ /-o/) {
			$outfile = shift(@ARGV);
		} elsif ($arg =~ /-aw/) {	
			$ADDRWIDTH = shift(@ARGV);
		} elsif ($arg =~ /-sep/) {
			$SEPARATION = shift(@ARGV);
		} elsif ($arg =~ /-hole/) {
			$x = shift(@ARGV);
			$y = shift(@ARGV);
			push(@HOLES,"$x,$y");
		} else {
			print "Unrecognized option: $arg\n";
			exit;
		}
	}
}


######################################################################
## main program
######################################################################

# an A4 page is 210x297 mm
### globals ### Some of these are defaults that can be overridden on cmd line
$CM			= 72 / 2.54;	# points per centimeter
$A4WIDTH	= 21.0;	# cm
$A4HEIGHT	= 29.7;	# cm
#$A4HEIGHT	= 27.0;	# cm (fake it for GhostScript)

$USWIDTH	= 8.5 * 2.54;
$USHEIGHT	= 11 * 2.54;

$PAGESPERSHEET	= 4;
$PAPERSIZE	= 'A4';
$debug		= 0;
$PHYSPAGE	= 0;
$LOGPAGE	= 0;	# logical page
$FIRSTMARK	= 1;	# is this first name on logical page?
$FIRSTLET	= '';	# First letter of first name on page (for header)
$PAGEWIDTH	= 9.0;	# cm
$PAGEHEIGHT	= 12.0;	# cm
$LEFTMARGIN	= 1.0;	# cm
$RIGHTMARGIN= 0.2;	# cm
$TOPMARGIN	= 0.7;	# cm
$BOTMARGIN	= 0.2;	# cm
$PTSPERCM	= 28.346456;
$FONTNAME	= 'Times-Roman';
$FONTSCALE	= 9;
@HOLES		= ();
ParseArgs();
if (!$SEPARATION) {
	$SEPARATION	= 0.3;	# cm
}
if (!$ADDRWIDTH) {
	$ADDRWIDTH	= 17.0 / 32.0 *
		($PAGEWIDTH - $LEFTMARGIN - $RIGHTMARGIN - $SEPARATION);
}
$HEADERSCALE= $FONTSCALE * 1.5;
$PTSLEFT	= $PTSPERCM * $PAGEHEIGHT;
$BOT_Y		= -($PAGEHEIGHT - $BOTMARGIN) * $CM;
$TELWIDTH	= $PAGEWIDTH -
			  ($LEFTMARGIN + $ADDRWIDTH + $SEPARATION + $RIGHTMARGIN);
$TELSTART	= $LEFTMARGIN + $ADDRWIDTH + $SEPARATION;

Dbg("ADDRWIDTH = $ADDRWIDTH");
# hole measurements
#$HoleSeparation	= 1.9;	# cm
#$HoleToTop		= 1.2;
#$HoleToSide		= 0.5;
$HoleRadius		= 0.25;
#$NumHoles		= 6;

$header		= './header.ps';


PageSetup();

#$outfile	= $ARGV[0];
open(HEAD,$header) || die "couldn't open $header for reading";
open(OUT,">$outfile") || die "couldn't open $outfile for writing";
while(<HEAD>) {
	print OUT;
}
close(IN);

print OUT "%%%%\n";
print OUT "%%%% END OF PROLOGUE\n";
print OUT "%%%%\n\n";

# save the width (in points) of the address & telephone area for the
# PostScript ShowAddr and ShowTel routines
print OUT "/addrwidth $ADDRWIDTH cm def\n";
print OUT "/telwidth $TELWIDTH cm def\n";
print OUT "/fontscale $FONTSCALE def\n";
print OUT "/headerscale $HEADERSCALE def\n";
print OUT "/fontname /${FONTNAME}-Enhanced def\n";

SetupFonts();
InitCurY();
NewPhysicalPage();

while(<STDIN>) {
	chomp;
	FormatPS($_);
}
DoHeader();
print OUT "showpage\n";
close(OUT);
